package core

// Core flag string constants
const (
	sysLogFlagStr = "sys-log"
	sysLogDescStr = "System log output location ['stdout', 'stderr', 'null', $filename]"

	accLogFlagStr = "acc-log"
	accLogDescStr = "Access log output location ['stdout', 'stderr', 'null', $filename]"

	rootFlagStr = "root"
	rootDescStr = "Server root directory"

	bindFlagStr = "bind-addr"
	bindDescStr = "IP address to bind to"

	hostnameFlagStr = "hostname"
	hostnameDescStr = "Server hostname (FQDN)"

	portFlagStr = "port"
	portDescStr = "Port to listen on"

	fwdPortFlagStr = "fwd-port"
	fwdPortDescStr = "Outward-facing port"

	connReadTimeoutFlagStr = "conn-read-timeout"
	connReadTimeoutDescStr = "Client connection read timeout"

	connWriteTimeoutFlagStr = "conn-write-timeout"
	connWriteTimeoutDescStr = "Client connection write timeout"

	connReadBufFlagStr = "conn-read-buf"
	connReadBufDescStr = "Connection read buffer size (bytes)"

	connWriteBufFlagStr = "conn-write-buf"
	connWriteBufDescStr = "Connection write buffer size (bytes)"

	connReadMaxFlagStr = "conn-read-max"
	connReadMaxDescStr = "Connection read max (bytes)"

	fileReadBufFlagStr = "file-read-buf"
	fileReadBufDescStr = "File read buffer size (bytes)"

	monitorSleepTimeFlagStr = "cache-monitor-freq"
	monitorSleepTimeDescStr = "File cache freshness monitor frequency"

	cacheFileMaxFlagStr = "cache-file-max"
	cacheFileMaxDescStr = "Max cached file size (megabytes)"

	cacheSizeFlagStr = "cache-size"
	cacheSizeDescStr = "File cache size"

	cacheAgeMaxFlagStr = "cache-age-max"
	cacheAgeMaxDescStr = "Maximum cached file age before purge"

	restrictPathsFlagStr = "restrict-paths"
	restrictPathsDescStr = "Restrict paths as new-line separated list of regex statements (see documenation)"

	hiddenPathsFlagStr = "hidden-paths"
	hiddenPathsDescStr = "Hidden paths as new-line separated list of regex statements (see documentation)"

	remapRequestsFlagStr = "remap-requests"
	remapRequestsDescStr = "Remap requests as new-line separated list of remap statements (see documenation)"

	scgiPathsFlagStr = "scgi-maps"
	scgiPathsDescStr = "SCGI request maps (to unix SCGI socket) as new-line separated list of map statements (see documentation)"

	scgiReadBufFlagStr = "scgi-read-buf"
	scgiReadBufDescStr = "SCGI connection read buffer size (bytes)"

	scgiReadTimeoutFlagStr = "scgi-read-timeout"
	scgiReadTimeoutDescStr = "SCGI connection read timeout"

	scgiWriteTimeoutFlagStr = "scgi-write-timeout"
	scgiWriteTimeoutDescStr = "SCGI connection write timeout"

	cgiDirFlagStr = "cgi-dir"
	cgiDirDescStr = "CGI scripts directory (empty to disable)"

	maxCGITimeFlagStr = "max-cgi-time"
	maxCGITimeDescStr = "Maximum CGI script execution time"

	safePathFlagStr = "safe-path"
	safePathDescStr = "CGI environment safe PATH variable"

	userDirFlagStr = "user-dir"
	userDirDescStr = "User subdir for personal server space"

	versionFlagStr = "version"
	versionDescStr = "Print version string"
)

// Log string constants
const (
	hostnameBindEmptyStr = "At least one of hostname or bind-addr must be non-empty!"

	chDirStr    = "Entered server dir: %s"
	chDirErrStr = "Error entering server directory: %s"

	listenerBeginFailStr = "Failed to start listener on %s://%s:%s (%s:%s) - %s"
	listeningOnStr       = "Listening on %s://%s:%s (%s:%s)"

	cacheMonitorStartStr = "Starting cache monitor with freq: %s"
	cacheFileStatErrStr  = "Failed to stat file in cache: %s"

	pathRestrictionsEnabledStr      = "Path restrictions enabled"
	pathRestrictionsDisabledStr     = "Path restrictions disabled"
	pathRestrictRegexCompileFailStr = "Failed compiling restricted path regex: %s"
	pathRestrictRegexCompiledStr    = "Compiled restricted path regex: %s"

	pathHidingEnabledStr          = "Path hiding enabled"
	pathHidingDisableStr          = "Path hiding disabled"
	pathHidingRegexCompileFailStr = "Failed compiling hidden path regex: %s"
	pathHidingRegexCompiledStr    = "Compiled hidden path regex: %s"

	requestRemapEnabledStr          = "Request remapping enabled"
	requestRemapDisabledStr         = "Request remapping disabled"
	requestRemapRegexInvalidStr     = "Invalid request remap regex: %s"
	requestRemapRegexCompileFailStr = "Failed compiling request remap regex: %s"
	requestRemapRegexCompiledStr    = "Compiled path remap regex: %s"
	requestRemappedStr              = "Remapped request: %s %s"

	scgiSupportEnabledStr        = "SCGI support enabled"
	scgiSupportDisabledStr       = "SCGI support disabled"
	scgiMapRegexInvalidStr       = "Invalid SCGI request map regex: %s"
	scgiMapRegexCompileFailedStr = "Failed compiling SCGI request map regex: %s"
	scgiMapRegexCompiledStr      = "Compiled SCGI path map regex: %s"
	scgiRequestMappedStr         = "SCGI mapped request: %s %s"

	cgiPathStr            = "CGI safe path: %s"
	cgiSupportEnabledStr  = "CGI script support enabled"
	cgiSupportDisabledStr = "CGI script support disabled"
	cgiDirOutsideRootStr  = "CGI directory must not be outside server root!"
	cgiDirStr             = "CGI directory: %s"
	cgiExecuteErrStr      = "Exit executing: %s [%d]"

	userDirEnabledStr         = "User directory support enabled"
	userDirDisabledStr        = "User directory support disabled"
	userDirBackTraverseErrStr = "User directory with back-traversal not supported: %s"
	userDirStr                = "User directory: %s"

	signalReceivedStr = "Signal received: %v. Shutting down..."

	logOutputErrStr = "Error opening log output %s: %s"

	pgidNotFoundErrStr = "Process unfinished, PGID not found!"
	pgidStopErrStr     = "Error stopping process group %d: %s"

	connWriteErrStr       = "Conn write error"
	connReadErrStr        = "Conn read error"
	connCloseErrStr       = "Conn close error"
	listenerResolveErrStr = "Listener resolve error"
	listenerBeginErrStr   = "Listener begin error"
	listenerAcceptErrStr  = "Listener accept error"
	invalidIPErrStr       = "Invalid IP"
	invalidPortErrStr     = "Invalid port"
	mutexUpgradeErrStr    = "Mutex upgrade fail"
	mutexDowngradeErrStr  = "Mutex downgrade fail"
	fileOpenErrStr        = "File open error"
	fileStatErrStr        = "File stat error"
	fileReadErrStr        = "File read error"
	fileTypeErrStr        = "Unsupported file type"
	directoryReadErrStr   = "Directory read error"
	restrictedPathErrStr  = "Restricted path"
	invalidRequestErrStr  = "Invalid request"
	cgiStartErrStr        = "CGI start error"
	cgiExitCodeErrStr     = "CGI non-zero exit code"
	scgiDialErrStr        = "SCGI socket dial error"
	scgiWriteErrStr       = "SCGI write error"
)
